routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect()->route('login');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

// Controller de Clientes acessível somente para usuário autenticado
Route::middleware(['auth'])->group(function(){
	Route::get('/clientes/monitor', 'ClientsController@getMonitorData');
	Route::get('/monitor', 'ClientsController@monitor');
	Route::get('/auditoria/relatorio', 'ActionAuditsController@report');

	Route::resource('clientes', 'ClientsController');
	Route::resource('formas_contato', 'ContactMeansController');
	Route::resource('auditoria', 'ActionAuditsController');
});

app/Client.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Client extends Model
{
    use SoftDeletes;

    protected $fillable = ['name','cpf','rg','birth_date','address','post_address'];
    protected $dates = ['deleted_at'];
}

app/Http/Controllers/ClientsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use App\User;
use App\Client;
use App\ContactMean;
use App\ClientContact;
use App\ActionAudit;

class ClientsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $clients = Client::all('id','name','cpf','rg','birth_date','address');
        
        $clients = json_decode($clients,true);  

        foreach ($clients as $key => $client) {
            $clients[$key]['age'] = $this->getClientAge($client['birth_date']);
            $clients[$key]['birth_date'] = date('d/m/Y', strtotime($clients[$key]['birth_date']));
        }

        $clients = json_encode($clients);

        // formas de contato
        $contactMeans = ContactMean::getFields();

        return view('clients.index', compact('clients','contactMeans'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $request->all();

        $validation = $this->toValidate($data);

        if ( $validation->fails() ) {
            return redirect()->back()->withErrors($validation)->withInput();
        }

        $client = Client::create($data);

        // Auditoria de ação
        $this->setAudit('Inserção', $client->id);

        // Se existir formas de contato na persistência, tratar
        if ( isset($data['contact_means']) && !empty($data['contact_means']) ) {
            $this->contactMeans($client->id,$data['contact_means']);
        }

        return redirect()->back();
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {   
        $client = Client::find($id);
        $client['contact_means'] = $this->getContactMeans($id);
        $client['contact_means_title'] = $this->getContactMeansTitle($client['contact_means']);

        if ( count($client['contact_means_title']) < 1 ) {
            $client['contact_means_title'] = 'Nenhuma forma vinculada';
        }

        return $client;
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $request->all();

        $validation = $this->toValidate($data,$id);

        if ( $validation->fails() ) {
            return redirect()->back()->withErrors($validation)->withInput();
        }

        Client::find($id)->update($data);

        // Auditoria de ação
        $this->setAudit('Alteração', $id);

        // Se existir formas de contato na persistência, tratar
        if ( isset($data['contact_means']) && !empty($data['contact_means']) ) {
            $this->contactMeans($id,$data['contact_means']);
        }
        
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Client::find($id)->delete();

        // Auditoria de ação
        $this->setAudit('Remoção', $id);
        return redirect()->back();
    }

    /**
     * Busca informações atuais de total de clientes e idades
     * 
     * @return \Illuminate\Http\Response
     */
    public function getMonitorData() {
        $clients = Client::all('birth_date');
        $clients = json_decode($clients,true); 

        $totalAges = 0; 

        foreach ($clients as $key => $client) {
            $totalAges += intval( $this->getClientAge($client['birth_date'] ));
        }

        $totalClients = Client::count();

        $data = [ 'totalClients' => $totalClients, 'totalAges' => $totalAges];
        return response()->json($data);
    }

     /**
     * Action da tela de monitor
     *
     * @param  View da tela de monitor
     */
    public function monitor() {
        return view('clients.monitor');
    }

    /**
     * Persiste as formas de contato.
     *
     * @param  int  $id identificador do cliente
     * @param  Array  $contact_means identificadores das formas de contato
     */
    private function contactMeans($id,$contact_means) {
        foreach ($contact_means as $contact_mean) {
            ClientContact::create(['client_id'=>$id, 'contact_mean_id' => $contact_mean]);
        }
    }

    /**
     * Busca id das formas de contato.
     *
     * @param  int  $id identificador do cliente
     * @param  Array  $contact_means identificadores das formas de contato
     */
    private function getContactMeans($id) {
        $resp = ClientContact::where('client_id','=',$id)->get();
        $contactMeans = [];

        for ($i=0; $i < count($resp) ; $i++) { 
            $contactMeans[$i] = $resp[$i]['contact_mean_id'];
        }

        return $contactMeans;
    }

    /**
     * Busca título das formas de contato.
     *
     */
    private function getContactMeansTitle($contactMeansIds) {
        $titles = [];

        foreach ($contactMeansIds as $key => $contactMeansId) {
            $contactMean = ContactMean::getField($contactMeansId); 
            $contactMean = json_decode($contactMean,true);

            foreach ($contactMean as $key => $type) {
                if ($key == 'title') {
                    $titles[] = $contactMean[$key]['title'];
                }
            }
        }

        return $titles;
    }
    /**
     * Valida dados que serão persistidos.
     *
     * @param  App\Client  $client
     * @param  Boolean  $id
     * @return Mixed $validation
     */
    private function toValidate($client,$id = false) {
        // Quando for um registro existente é necessário ignorar a validação
        if ($id) {
            $validation = \Validator::make($client,[
                'name' => 'required',
                'cpf' => ['required',Rule::unique('clients')->ignore($id)],
                'rg' => ['required',Rule::unique('clients')->ignore($id)],
                'birth_date' => 'required',
                'address' => 'required',
                'post_address' => 'required',
            ]);

            return  $validation;
        }

        $validation = \Validator::make($client,[
            'name' => 'required',
            'cpf' => ['required',Rule::unique('clients')],
            'rg' => ['required',Rule::unique('clients')],
            'birth_date' => 'required',
            'address' => 'required',
            'post_address' => 'required',
        ]);

        return  $validation;
    }

    /**
     * Calcula idade do cliente
     *
     * @param  String $birth_date data de nascimento
     * @return String Idade do cliente
     */
    private function getClientAge($birth_date) {
        return (date('Y') - date('Y',strtotime($birth_date)));
    }

    /**
     * Persiste auditoria cliente
     *
     * @param  String $action ação para log
     * @return Int registryId identificador do cliente
     */
    private function setAudit($action,$registryId) {
        $user = Auth::user();

        // Auditoria
        $audit = [
            'user_id' => $user->id,
            'user_login' => $user->name . ' - ' . $user->email,
            'date' => date('Y-m-d H:i:s'),
            'local' => 'Clientes',
            'action' => $action,
            'registry_id' => $registryId,
        ];

        ActionAudit::create($audit);
    }
}

resources/views/clients/index.blade.php
@extends('layouts.app')

@section('content')
    <page-component>
        @if($errors->all())
            <div class="alert alert-danger alert-dismissible" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                @if($errors->all())   
                    @foreach ($errors->all() as $value)
                        <li>{{ $value }}</li>
                    @endforeach
                @endif
            </div>
        @endif

        <panel-component headline="Clientes">
        	<table-component 
        		v-bind:fields="['ID','Nome','CPF','RG','Data Nascimento', 'Endereço', 'Idade']"
        		v-bind:items="{{ $clients }}"
                read = "/clientes/"
                update = "/clientes/"
                remove = "/clientes/"
        		token="{{ csrf_token() }}">
        	</table-component>
        </panel-component>
    </page-component>

    {{-- Modal para adicionar novo cliente --}}
    <modal-component id="toCreate" title="Novo">
        <form-component 
            id="form-create"
            action="{{ route('clientes.store') }}" 
            method="POST"
            enctype=""
            token="{{ csrf_token() }}">

            {{-- Nome do Cliente --}}
            <div class="form-group">
                <label for="name">Nome</label>
                <input type="text" required="true" class="form-control" id="name" name="name" placeholder="Ex: João Silva" value="{{ old('name') }}">
            </div>

            {{-- CPF do Cliente --}}
            <div class="form-group">
                <label for="cpf">CPF</label>
                <input type="text" required="true" onkeyup="onlyNumber(this);" maxlength="11" class="form-control" id="cpf" name="cpf" placeholder="Ex: 01234567890" value="{{ old('cpf') }}">
            </div>

            {{-- RG do Cliente --}}
            <div class="form-group">
                <label for="rg">RG</label>
                <input type="text" required="true" onkeyup="onlyNumber(this);"maxlength="12" class="form-control" id="rg" name="rg" placeholder="Ex: 01234567890" value="{{ old('rg') }}">
            </div>

            {{-- Data Nascimento do Cliente --}}
            <div class="form-group">
                <label for="birth_date">Data Nascimento</label>
                <input type="date" required="true" class="form-control" id="birth_date" name="birth_date" placeholder="Ex: 20/07/1980" value="{{ old('birth_date') }}">
            </div>

            {{-- Endereço do Cliente --}}
            <div class="form-group">
                <label for="address">Endereço Residencial</label>
                <input type="text" required="true" class="form-control" id="address" name="address" placeholder="Ex: Avenida Hélvio Basso, 1666" value="{{ old('address') }}">
            </div>

            {{-- Endereço correspondência do Cliente --}}
            <div class="form-group">
                <label for="post_address">Endereço de Correspondência</label>
                <input type="text" required="true" class="form-control" id="post_address" name="post_address" placeholder="Ex: Avenida Hélvio Basso, 1666" value="{{ old('post_address') }}">
            </div>

            {{-- Formas de Contato --}}
            <checkbox-component v-bind:items="{{ $contactMeans }}"></checkbox-component>
        </form-component>

        {{-- Botões --}}
        <span slot="buttons">
            <button form="form-create" class="btn btn-info">Salvar</button>
        </span>
    </modal-component>

    {{-- Modal para editar cliente --}}
    <modal-component id="toUpdate" title="Editar">
        <form-component 
            id="form-edit"
            v-bind:action="'/clientes/' + $store.state.item.id" 
            method="PUT"
            enctype="multipart/form-data" 
            token="{{ csrf_token() }}">

            {{-- Nome do Cliente --}}
            <div class="form-group">
                <label for="name">Nome</label>
                <input type="text" required="true" class="form-control" id="name" name="name" v-model="$store.state.item.name">
            </div>

            {{-- CPF do Cliente --}}
            <div class="form-group">
                <label for="cpf">CPF</label>
                <input type="text" required="true" onkeyup="onlyNumber(this);" maxlength="11" class="form-control" id="cpf" name="cpf" v-model="$store.state.item.cpf">
            </div>

            {{-- RG do Cliente --}}
            <div class="form-group">
                <label for="rg">RG</label>
                <input type="text" required="true" onkeyup="onlyNumber(this);" maxlength="12" class="form-control" id="rg" name="rg" placeholder="01234567890" v-model="$store.state.item.rg">
            </div>

            {{-- Data Nascimento do Cliente --}}
            <div class="form-group">
                <label for="birth_date">Data Nascimento</label>
                <input type="date" required="true" class="form-control" id="birth_date" name="birth_date" placeholder="20/07/1980" v-model="$store.state.item.birth_date">
            </div>

            {{-- Endereço do Cliente --}}
            <div class="form-group">
                <label for="address">Endereço Residencial</label>
                <input type="text" required="true" class="form-control" id="address" name="address" placeholder="Avenida Hélvio Basso, 367" v-model="$store.state.item.address">
            </div>

            {{-- Endereço correspondência do Cliente --}}
            <div class="form-group">
                <label for="post_address">Endereço de Correspondência</label>
                <input type="text" required="true" class="form-control" id="post_address" name="post_address" placeholder="Avenida Hélvio Basso, 367" v-model="$store.state.item.post_address">
            </div>

            {{-- Formas de Contato --}}
            <checkbox-component v-bind:items="{{ $contactMeans }}"></checkbox-component>

        </form-component>

        {{-- Botões --}}
        <span slot="buttons">
            <button form="form-edit" class="btn btn-info">Salvar</button>
        </span>
    </modal-component>

    {{-- Modal para visualizar detalhes do cliente --}}
    <modal-component id="toRead" title="Detalhes">
        {{-- Nome do Cliente --}}
        <div class="form-group">
            <label for="name">Nome: </label> 
            @{{ $store.state.item.name }}
        </div>

        {{-- Endereço Postal do Cliente --}}
        <div class="form-group">
            <label for="post_address">Endereço Postal: </label>
             @{{ $store.state.item.post_address }}
        </div>

        <div class="form-group">
            <label for="contact_means">Formas de Contato: </label>
             @{{ $store.state.item.contact_means_title }}
        </div>
    </modal-component>
@endsection

<style type="text/css">
    table {
        font-size: 14px;
    }
</style>

<script type="text/javascript">
    function onlyNumber(param) {
        var er = /[^0-9]/;
        er.lastIndex = 0;
        var field = param;
        if (er.test(field.value)) {
          field.value = "";
        }
    }
</script>

resources/views/clients/monitor.blade.php
@extends('layouts.app')

@section('content')
    <page-component>
        <panel-component headline="Monitor">
            <h3>
                Clientes <span style="font-size:15px;" id="totalClients" class="badge badge-info">Carregando...</span>,
                soma das idades   <span style="font-size:15px;" id="totalAges" class="badge badge-info">Carregando...</span> anos
            </h3>
        </panel-component>
    </page-component>
@endsection

<script src="http://code.jquery.com/jquery-3.3.1.min.js"
        integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8="
        crossorigin="anonymous">
</script>
<script>
  $( document ).ready(function() {
        //Necessidade de criar uma função que fica monitorando e alterando os valores na view
        setInterval(function(){
            $.ajax({
                url: "/clientes/monitor",
                method: "get",
                success: function(data){
                  document.getElementById('totalClients').innerHTML = data.totalClients;
                  document.getElementById('totalAges').innerHTML = data.totalAges;
              }
            });
        }, 1500);
  });
</script>